// 002 u_double
// 12 mar 05

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_double;
  interface

    Function f_power(p_base: Double; p_exponent: Integer): Double;
    function f_double_is_null(l_double: Double): boolean;
    function f_double_are_equal(l_double_1, l_double_2: Double): boolean;

    function f_display_double(p_double: Double; p_integer, p_decimal: Integer): String;

    var g_epsilon: Double= 1e-15;

  implementation
    uses SysUtils;

    Function f_power(p_base: Double; p_exponent: Integer): Double;
      Var l_value: Double;
          l_exponant: Integer;
      Begin
        If p_exponent= 0
          Then Result:= 1
          Else
            begin
              l_value:= 1.0;
              For l_exponant:= 1 To p_exponent Do
                l_value:= l_value* p_base;
              Result:= l_value
            End;
      End; // f_power

    function f_double_is_null(l_double: Double): boolean;
      begin
        Result:= abs(l_double)< g_epsilon;
      end; // f_double_is_null

    function f_double_are_equal(l_double_1, l_double_2: Double): boolean;
      begin
        Result:= abs(l_double_1- l_double_2)< g_epsilon
      end; // f_double_are_equal

    function f_display_double(p_double: Double; p_integer, p_decimal: Integer): String;
      begin
        Result:= FloatToStrF(p_double, ffFixed, p_integer, p_decimal);
      end; // f_display_double

    begin // principal
    end. // principal
